summaryrefslogtreecommitdiff
path: root/plugins
diff options
context:
space:
mode:
authorMarc Cornellà <marc.cornella@live.com>2016-09-04 22:51:20 +0200
committerGitHub <noreply@github.com>2016-09-04 22:51:20 +0200
commite92ac8932cf0b5ab5d7f4a662bb57c9039c47920 (patch)
tree780f13f2e1d3b63073cd3cd34e3f4b044d4712a8 /plugins
parent7d5bb2a34dd221174c85b826a71d874da3ffc0ec (diff)
parent53c3567cc395127d6ba90b8a010e8f7a48a16713 (diff)
downloadzsh-e92ac8932cf0b5ab5d7f4a662bb57c9039c47920.tar.gz
zsh-e92ac8932cf0b5ab5d7f4a662bb57c9039c47920.tar.bz2
zsh-e92ac8932cf0b5ab5d7f4a662bb57c9039c47920.zip
Merge pull request #5328 from mcornella/ssh-agent-refactor
Refactor of ssh-agent plugin
Diffstat (limited to 'plugins')
-rw-r--r--plugins/ssh-agent/README.md38
-rw-r--r--plugins/ssh-agent/ssh-agent.plugin.zsh93
2 files changed, 66 insertions, 65 deletions
diff --git a/plugins/ssh-agent/README.md b/plugins/ssh-agent/README.md
new file mode 100644
index 000000000..00af42f01
--- /dev/null
+++ b/plugins/ssh-agent/README.md
@@ -0,0 +1,38 @@
+# ssh-agent plugin
+
+This plugin starts automatically `ssh-agent` to set up and load whichever
+credentials you want for ssh connections.
+
+To enable it, add `ssh-agent` to your plugins:
+
+```zsh
+plugins=(... ssh-agent)
+```
+
+## Instructions
+
+To enable **agent forwarding support** add the following to your zshrc file:
+
+```zsh
+zstyle :omz:plugins:ssh-agent agent-forwarding on
+```
+
+To **load multiple identities** use the `identities` style, For example:
+
+```zsh
+zstyle :omz:plugins:ssh-agent identities id_rsa id_rsa2 id_github
+```
+
+To **set the maximum lifetime of the identities**, use the `lifetime` style.
+The lifetime may be specified in seconds or as described in sshd_config(5)
+(see _TIME FORMATS_). If left unspecified, the default lifetime is forever.
+
+```zsh
+zstyle :omz:plugins:ssh-agent lifetime 4h
+```
+
+## Credits
+
+Based on code from Joseph M. Reagle: http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
+
+Agent-forwarding support based on ideas from Florent Thoumie and Jonas Pfenniger
diff --git a/plugins/ssh-agent/ssh-agent.plugin.zsh b/plugins/ssh-agent/ssh-agent.plugin.zsh
index b77b9ee78..a84aac58c 100644
--- a/plugins/ssh-agent/ssh-agent.plugin.zsh
+++ b/plugins/ssh-agent/ssh-agent.plugin.zsh
@@ -1,79 +1,42 @@
-#
-# INSTRUCTIONS
-#
-# To enable agent forwarding support add the following to
-# your .zshrc file:
-#
-# zstyle :omz:plugins:ssh-agent agent-forwarding on
-#
-# To load multiple identities use the identities style, For
-# example:
-#
-# zstyle :omz:plugins:ssh-agent identities id_rsa id_rsa2 id_github
-#
-# To set the maximum lifetime of the identities, use the
-# lifetime style. The lifetime may be specified in seconds
-# or as described in sshd_config(5) (see TIME FORMATS)
-# If left unspecified, the default lifetime is forever.
-#
-# zstyle :omz:plugins:ssh-agent lifetime 4h
-#
-# CREDITS
-#
-# Based on code from Joseph M. Reagle
-# http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
-#
-# Agent forwarding support based on ideas from
-# Florent Thoumie and Jonas Pfenniger
-#
+typeset _agent_forwarding _ssh_env_cache
-local _plugin__ssh_env
-local _plugin__forwarding
+function _start_agent() {
+ local lifetime
+ local -a identities
-function _plugin__start_agent()
-{
- local -a identities
- local lifetime
- zstyle -s :omz:plugins:ssh-agent lifetime lifetime
+ # start ssh-agent and setup environment
+ zstyle -s :omz:plugins:ssh-agent lifetime lifetime
- # start ssh-agent and setup environment
- /usr/bin/env ssh-agent ${lifetime:+-t} ${lifetime} | sed 's/^echo/#echo/' >! ${_plugin__ssh_env}
- chmod 600 ${_plugin__ssh_env}
- . ${_plugin__ssh_env} > /dev/null
+ ssh-agent -s ${lifetime:+-t} ${lifetime} | sed 's/^echo/#echo/' >! $_ssh_env_cache
+ chmod 600 $_ssh_env_cache
+ . $_ssh_env_cache > /dev/null
- # load identies
- zstyle -a :omz:plugins:ssh-agent identities identities
- echo starting ssh-agent...
+ # load identies
+ zstyle -a :omz:plugins:ssh-agent identities identities
- /usr/bin/ssh-add $HOME/.ssh/${^identities}
+ echo starting ssh-agent...
+ ssh-add $HOME/.ssh/${^identities}
}
# Get the filename to store/lookup the environment from
-if (( $+commands[scutil] )); then
- # It's OS X!
- _plugin__ssh_env="$HOME/.ssh/environment-$(scutil --get ComputerName)"
-else
- _plugin__ssh_env="$HOME/.ssh/environment-$HOST"
-fi
+_ssh_env_cache="$HOME/.ssh/environment-$SHORT_HOST"
# test if agent-forwarding is enabled
-zstyle -b :omz:plugins:ssh-agent agent-forwarding _plugin__forwarding
-if [[ ${_plugin__forwarding} == "yes" && -n "$SSH_AUTH_SOCK" ]]; then
- # Add a nifty symlink for screen/tmux if agent forwarding
- [[ -L $SSH_AUTH_SOCK ]] || ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USER-screen
-
-elif [ -f "${_plugin__ssh_env}" ]; then
- # Source SSH settings, if applicable
- . ${_plugin__ssh_env} > /dev/null
- ps x | grep ${SSH_AGENT_PID} | grep ssh-agent > /dev/null || {
- _plugin__start_agent;
- }
+zstyle -b :omz:plugins:ssh-agent agent-forwarding _agent_forwarding
+
+if [[ $_agent_forwarding == "yes" && -n "$SSH_AUTH_SOCK" ]]; then
+ # Add a nifty symlink for screen/tmux if agent forwarding
+ [[ -L $SSH_AUTH_SOCK ]] || ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USER-screen
+elif [[ -f "$_ssh_env_cache" ]]; then
+ # Source SSH settings, if applicable
+ . $_ssh_env_cache > /dev/null
+ ps -o cmd -p $SSH_AGENT_PID | grep -q ssh-agent || {
+ _start_agent
+ }
else
- _plugin__start_agent;
+ _start_agent
fi
# tidy up after ourselves
-unfunction _plugin__start_agent
-unset _plugin__forwarding
-unset _plugin__ssh_env
-
+unset _agent_forwarding _ssh_env_cache
+unfunction _start_agent